Integrate payment processing
Payment processing with Mercado Pago Point integrated into your point of sale is based on creating orders that have an associated payment transaction. When an order is created, it will be automatically loaded to the specified terminal, and the buyer will be able to make the payment in person.
In PDV mode, the seller creates an order and it is automatically sent to the indicated Point terminal, allowing the buyer to make the payment. In the case of SELF-SERVICE mode, the order is processed in real time between the kiosk used by the buyer and Mercado Pago, without the need for manual intervention. Additionally, in SELF_SERVICE mode, the terminal will be dedicated exclusively to payment processing, with restricted access to settings and advanced features.
Integrated payment processing with Mercado Pago Point will allow you to create orders, process them, cancel them, or make refunds and query their information or status updates.
To start processing payments with Point from points of sale, you first need to identify which terminal you want to assign the order to. Remember that this terminal must be set to PDV or SELF-SERVICE mode.
For this, send a GET to the endpoint Get list of terminalsAPI. Use your test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials.
We recommend filtering the search by using the optional query params store_id and pos_id, store and box identifiers returned in the response to the creation of each one.
curl
curl -X GET \ 'https://api.mercadopago.com/terminals/v1/list?limit=50&offset=0&store_id=12354567&pos_id=23545678' \ -H 'Content-Type: application/json' \ -H 'Authorization: Bearer TEST-232********97488-12********26f67454********f4c8b49c********9526408'
The response to this request will allow you to see the terminals associated with your account and select the one you want to use to create your order. You can identify it by the last characters of the id field, which should match the serial number on the back label of the physical terminal.
json
{ "data": { "terminals": [ { "id": "NEWLAND_N950__N950NCB801293324", "pos_id": "23545678", "store_id": "12354567", "external_pos_id": "SUC0101POS", "operating_mode": "PDV" } ] }, "paging": { "total": 1, "offset": 0, "limit": 50 } }
Then, you'll need to create the order. For this, send a POST to the endpoint /v1/ordersAPI, making sure to include your test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials, and the id of the terminal to which you want to assign the order, obtained in the previous step.
curl
curl -X POST \ 'https://api.mercadopago.com/v1/orders' \ -H 'Content-Type: application/json' \ -H 'X-Idempotency-Key: 0d5020ed-1af6-469c-ae06-c3bec19954bb' \ -H 'Authorization: Bearer TEST-232********97488-12********26f67454********f4c8b49c********9526408' \ -d '{ "type": "point", "external_reference": "ext_ref_1234", "expiration_time": "PT16M", "transactions": { "payments": [ { "amount": "24.00" } ] }, "config": { "point": { "screen_time": "PT15S", "terminal_id": "NEWLAND_N950__N950NCB801293324", "print_on_terminal": "no_ticket", "ticket_number": "S0392JED" }, "payment_method": { "default_type": "credit_card" } }, "description": "Point Smart 2", "integration_data": { "platform_id": "dev_1234567890", "integrator_id": "dev_1234567890", "sponsor": { "id": "446566691" } } }'
Check the table below for descriptions of parameters that have some important particularity that should be highlighted.
| Attribute | Type | Description | Required |
Authorization | Header | Refers to the test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials or the one obtained via OAuthPrivate key generated through the OAuth security protocol, which allows managing integrations on behalf of third parties. For more information, go to the documentation.OAuth. | Required |
X-Idempotency-Key | Header | Idempotency key. It is used to ensure that each request is processed only once, avoiding duplications. Use a unique value in the header of your request, such as a UUID V4 or random strings. | Required |
type | Body.String | Type of order, associated with the Mercado Pago solution for which it is being created. For payments with Mercado Pago Point, the only possible value is point. | Required |
external_reference | Body.String | It is an external reference of the order, assigned at the time of its creation. It must be a unique value for each order and cannot contain PII data. The maximum allowed limit is 64 characters and the allowed ones are: uppercase and lowercase letters, numbers and hyphen (-) and underscore (_) symbols. | Required |
expiration_time | Body. String | Indicates the validity period of the payment order from its creation. During this time, the order will be available for processing by the customer; if it is not processed within the specified period, it will automatically expire and cannot be used, requiring the generation of a new payment order to continue. The minimum allowed value is 30 seconds (PT30S) and the maximum is 3 hours (PT3H). Usage examples: for a 30-second expiration: "PT30S", for 10 minutes: "PT10M", and for 1 hour and 15 minutes: "PT1H15M". | Optional |
transaction.payments.amount | Body.String | Total amount of the payment order. El campo debe llevar obligatoriamente 2 números decimales, incluso cuando es un número entero (por ejemplo, "10.00"). | Required |
config.point.screen_time | Body.String | Allows you to specify the time that the terminal screens will be enabled to process the order, using ISO 8601 duration format (for example: "PT1M15S" represents a duration of 1 minute and 15 seconds, where the minimum possible value is 5 seconds and the maximum is 5 minutes). This time is reset every time the screen changes or the user interacts with the terminal. If not configured, the default value is 15 seconds. During the configured period, the order will be enabled to be processed; if it is not processed within this period, it will be canceled. If you wish to continue with the payment, you must create a new order. Important: the card reading screen for payment will be displayed for, at most, 60 seconds (1 minute) regardless of whether the value configured for this field is greater than 60 seconds. | Optional |
config.point.terminal_id | Body.String | Identifier of the Point terminal that will receive the order. You must send it exactly as it was returned in the Get terminalsAPI request, as in the following example: "NEWLAND_N950__N950NCB801293324". | Required |
If the request was successful, the response will return an order with a status created.
json
{ "id": "ORD00001111222233334444555566", "type": "point", "user_id": "5238400195", "external_reference": "ext_ref_1234", "description": "Point Smart 2", "expiration_time": "PT16M", "processing_mode": "automatic", "country_code": "ARG", "integration_data": { "application_id": "1234567890", "platform_id": "dev_1234567890", "integrator_id": "dev_1234567890", "sponsor": { "id": "446566691" } }, "status": "created", "status_detail": "created", "created_date": "2024-09-10T14:26:42.109320977Z", "last_updated_date": "2024-09-10T14:26:42.109320977Z", "config": { "point": { "terminal_id": "NEWLAND_N950__N950NCB801293324", "print_on_terminal": "no_ticket", "ticket_number": "S0392JED" }, "payment_method": { "default_type": "credit_card", } }, "transactions": { "payments": [ { "id": "PAY01J67CQQH5904WDBVZEM4JMEP3", "amount": "24.00", "status": "created" } ] }, }
id and the payment id (transactions.payments.id) obtained when creating it, as they will allow you to perform other operations and properly query your notifications. Additionally, you can consult our documentation in the Resources section to better understand the possible status of an order and a transaction.This created order will be automatically received by the terminal to which it was assigned. If the order is not automatically loaded on the terminal, you must press the Update button or, if the terminal has one, the green button to receive the order. In this way, the buyer can make the payment on the terminal and then it will be processed.Remember that if the expiration_time parameter is not filled in, the payment must be made within 15 minutes (for PDV mode) or within 15 seconds (for SELF_SERVICE mode) after the order is created. After this period, the order will expire.
An order can be cancelled in two ways, depending on its status.
- If the order's
statusiscreated, its cancellation must be done via API. - If the
statusisat_terminal, it has already been retrieved by the terminal and must be cancelled from there.
expiration_time parameter is not filled in, and the order is not processed within 15 minutes of its creation in PDV operation mode, or within 15 seconds in SELF_SERVICE operation mode, its status will become expired and it will no longer be possible to cancel it.
Additionally, in the case of cancellations from the terminal, it's important to have previously configured your Webhook notifications to receive the cancellation notice in your system, which will allow you to maintain your reconciliation.
Choose the option that best suits your needs to learn how to cancel your order.
If you want to cancel an order with created status, you'll need to send a POST to the /v1/orders/{order_id}/cancelAPI endpoint, making sure to include your test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials. You must also send the id of the order you want to cancel, obtained in the response to its creation.
curl
curl -X POST \ 'https://api.mercadopago.com/v1/orders/ORDER_ID/cancel' \ -H 'Content-Type: application/json' \ -H 'X-Idempotency-Key: 0d5020ed-1af6-469c-ae06-c3bec19954bb' \ -H 'Authorization: Bearer ACCESS_TOKEN'
If the request was successful, the response will show a status=canceled.
json
{ "id": "ORD0000ABCD222233334444555566", "user_id": "5238400195", "type": "point", "external_reference": "ext_ref_1234", "description": "Point Smart 2", "expiration_time": "PT16M", "country_code": "ARG", "processing_mode": "automatic", "integration_data": { "application_id": "1234567890", "platform_id": "dev_1234567890", "integrator_id": "dev_1234567890", "sponsor": { "id": "446566691" } }, "status": "canceled", "status_detail": "canceled", "created_date": "2024-09-10T14:26:42.109320977Z", "last_updated_date": "2024-09-10T14:26:42.109320977Z", "config": { "point": { "screen_time": "PT15S", "terminal_id": "NEWLAND_N950__N950NCB801293324", "print_on_terminal": "no_ticket", "ticket_number": "S0392JED" }, "payment_method": { "default_type": "credit_card", "default_installments": "6", "installments_cost": "seller" } }, "transactions": { "payments": [ { "id": "PAY01J67CQQH5904WDBVZEM4JMEP3", "amount": "24.00", "status": "canceled", "status_detail": "canceled_by_api" } ] }, }
If necessary, you can refund an order created through our API. This endpoint allows you to make a total or partial refund of a payment transaction associated with the order. To request a total refund, it is not necessary to send a body in the request. For a partial refund, you need to inform the amount to be refunded and the transaction identifier in the body.
Choose the option that best suits your needs and follow the corresponding instructions.
To make a total refund of an order, send a POST to the endpoint /v1/orders/{order_id}/refundAPI without sending the body in the request. Make sure to include your test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials. You also need to inform the id of the order you want to refund, obtained in the response to its creation.
curl
curl -X POST \ 'https://api.mercadopago.com/v1/orders/ORDER_ID/refund' \ -H 'Content-Type: application/json' \ -H 'X-Idempotency-Key: 0d5020ed-1af6-469c-ae06-c3bec19954bb' \ -H 'Authorization: Bearer ACCESS_TOKEN'
If the request was successful, the response will show status=refunded and will include a new node transactions.refunds, which will contain the refund details, along with the identifier of the original payment and the refund transaction.
json
{ "id": "ORD0000ABCD222233334444555566", "status": "refunded", "status_detail": "refunded", "transactions": { "refunds": [ { "id": "REF01J67CQQH5904WDBVZEM1234D", "transaction_id": "PAY01J67CQQH5904WDBVZEM4JMEP3", "reference_id": "12345678", "amount": "38.00", "status": "processed" } ] } }
If needed, you can query the data of an order and its associated transactions, whether payments or refunds, including their statuses or values.
Although the recurring use of this API query is not recommended, it can be useful if you need additional information about the order.
To query order data, send a GET to the endpoint /v1/orders/{order_id}API, making sure to include your test Access TokenPrivate key of the application created in Mercado Pago, used in the backend during integration development. You can access it in Your integrations > Application details > Tests > Test credentials. When going to production, replace it with the production Access Token if it is your own integration, or with the Access Token obtained via OAuth in the case of third-party integrations.Access test credentials, and the id of the order whose information you want to query, obtained in the response to its creation.
curl
curl -X GET \ 'https://api.mercadopago.com/v1/orders/ORDER_ID' \ -H 'Content-Type: application/json' \ -H 'Authorization: Bearer ACCESS_TOKEN'
If the request was successful, the response will return all the order information, including its status and the status of the payment and/or refund in real time:
json
{ "id": "ORD00001111222233334444555566", "user_id": "5238400195", "type": "point", "external_reference": "ext_ref_1234", "processing_mode": "automatic", "description": "Point Smart 2", "expiration_time": "PT16M", "country_code": "ARG", "integration_data": { "application_id": "1234567890", "platform_id": "dev_1234567890", "integrator_id": "dev_1234567890", "sponsor": { "id": "446566691" } }, "status": "refunded", "status_detail": "refunded", "created_date": "2024-09-10T14:26:42.109320977Z", "last_updated_date": "2024-09-10T14:26:42.109320977Z", "config": { "point": { "screen_time": "PT15S", "terminal_id": "NEWLAND_N950__N950NCB801293324", "print_on_terminal": "no_ticket", "ticket_number": "S0392JED" }, "payment_method": { "default_type": "credit_card", "default_installments": "6", "installments_cost": "seller" } }, "transactions": { "payments": [ { "id": "PAY01J67CQQH5904WDBVZEM4JMEP3", "amount": "24.00", "refunded_amount": "38.00", "tip_amount": "14.00", "paid_amount": "38.00", "status": "refunded", "status_detail": "created", "reference_id": "12345678", "payment_method": { "type": "credit_card", "installments": 1, "id": "master" } } ], "refunds": [ { "id": "REF01J67CQQH5904WDBVZEM1234D", "transaction_id": "PAY01J67CQQH5904WDBVZEM4JMEP3", "reference_id": "12345678", "amount": "38.00", "status": "processed" } ] }, }
